package lichen.ws.services;

import org.apache.axis2.AxisFault;
import org.apache.axis2.addressing.EndpointReference;
import org.apache.axis2.client.Options;
import org.apache.axis2.rpc.client.RPCServiceClient;
import org.apache.axis2.transport.http.HTTPConstants;

import javax.xml.namespace.QName;

/**
 * 基于axis2的web service的客户端程序
 * @author jcai
 */
public class Axis2ServiceClient {
    public static <T> T call(String serviceURL,String method,Class<T> returnType,Object ... parameters) throws AxisFault {
        // 创建 RPCServiceClient 对象
        RPCServiceClient serviceClient = new RPCServiceClient();
        // 通过 RPCServiceClient 对象,获取 Options 对象
        EndpointReference targetEPR = new EndpointReference(serviceURL);
        Options options = serviceClient.getOptions();
        options.setTo(targetEPR);
        // 声明返回值类型
        Class[] classes = new Class[] { returnType };
        // 指定要调用 Web services 方法及 WSDL 文件的命名空间
        QName opAddEntry1	=	new	QName("http://www.egfit.com/", method);
        options.setProperty(HTTPConstants.SO_TIMEOUT, new Integer(1000 * 60 * 60));
        options.setProperty(HTTPConstants.CONNECTION_TIMEOUT,	new Integer(1000 * 60 * 60));
        T r = returnType.cast(serviceClient.invokeBlocking(opAddEntry1, parameters, classes)[0]);
        // 关闭服务对象
        serviceClient.cleanup(); 
        serviceClient = null;

        return r;
    }
}
